library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity chorus_TB is
end chorus_TB;

architecture rtl of chorus_TB is

component chorus is
port (
         --In
       clk: in std_logic;      --Should be 50 MHz
	   reset_n: in std_logic;
       data_enable: in std_logic;
       chorus_enable: in std_logic;
	   delay_amp: in std_logic_vector(2 downto 0);
	   delay_freq: in std_logic_vector(3 downto 0);
	   mix_delay: in std_logic_vector(3 downto 0);
       data_in: in std_logic_vector(15 downto 0);

       --Out
	   data_ready: out std_logic;
       data_out: out std_logic_vector(15 downto 0)
       );
end component;

signal clk: std_logic;      --Should be 50 MHz
signal reset_n: std_logic;
signal data_enable: std_logic;
signal chorus_enable: std_logic;
signal delay_amp: std_logic_vector(2 downto 0);
signal delay_freq : std_logic_vector(3 downto 0);
signal mix_delay: std_logic_vector(3 downto 0);
signal data_in: std_logic_vector(15 downto 0);

signal data_ready: std_logic;
signal data_out: std_logic_vector(15 downto 0);

begin
	V1: chorus port map(
       --In
      clk => clk,      --Should be 50 MHz
	   reset_n => reset_n,
      data_enable => data_enable,
      chorus_enable => chorus_enable,
	   delay_amp => delay_amp,
	   delay_freq => delay_freq,
	   mix_delay => mix_delay,
       data_in	=> data_in,

       --Out
	   data_ready => data_ready,
       data_out => data_out
    );
	

	process
	begin
		clk <='0';
		reset_n <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
		clk <='0';
		reset_n <= '1';
		wait for 5 ns;
		loop
			clk <='1';
			wait for 5 ns;
			clk <='0';
			wait for 5 ns;
		end loop;
	end process;

	process
	begin
		chorus_enable <= '1';
		delay_amp <= "010"; -- -128 to 127
		mix_delay <= "0111";
		delay_freq <= "0101";
		data_in <= X"0000";
		wait for 100 ns;
		loop
			data_enable <= '1';
			data_in <= data_in + 1;
			wait for 10 ns;
			data_enable <= '0';
			wait for 100 ns;
		end loop;
	end process;
		
end rtl;
