 library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity de2_wm8731_audio_out_TB is
end de2_wm8731_audio_out_TB;


architecture eda of de2_wm8731_audio_out_TB is
component de2_wm8731_audio_out is
port (
    clk : in std_logic;       --  Audio CODEC Chip Clock AUD_XCK (18.43 MHz)
    reset_n : in std_logic;
    test_mode : in std_logic;       --    Audio CODEC controller test mode
    data : in std_logic_vector(15 downto 0);	
	audio_req : out std_logic;
  
    -- Audio interface signals
--    AUD_ADCLRCK  : out std_logic;   --    Audio CODEC ADC LR Clock
    AUD_DACLRCK  : out std_logic;   --    Audio CODEC DAC LR Clock
    AUD_DACDAT   : out std_logic   --    Audio CODEC DAC Data
--    AUD_BCLK     : inout std_logic  --    Audio CODEC Bit-Stream Clock
  );
end  component;

signal clk : std_logic;
signal reset_n : std_logic;
signal test_mode : std_logic;
signal data : std_logic_vector(15 downto 0);
signal audio_req : std_logic;

signal AUD_DACDAT : std_logic;   --    Audio CODEC ADC Data
signal AUD_DACLRCK  : std_logic;   --    Audio CODEC ADC LR Clock
    -- Audio interface signals

begin

	P1: de2_wm8731_audio_out port map (
	    clk => clk,
	    reset_n => reset_n,
	    data => data,
		test_mode => test_mode,
		audio_req => audio_req,
	  
	    -- Audio interface signals
	    AUD_DACLRCK  => AUD_DACLRCK,
		AUD_DACDAT => AUD_DACDAT
	 );

	process
	begin
		clk <='0';
		reset_n <= '0';
		data <= "1010111000011100";
		wait for 5 ns;
		reset_n <= '1';
		loop
			clk <='1';
			wait for 5 ns;
			clk <='0';
			wait for 5 ns;
		end loop;
	end process;

--	process
--	begin
--	end process;
end eda;
