library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity vibrato_button_ctl2 is
port (
	clk: in std_logic;
	reset_n : in std_logic;
	button_up : in std_logic;
	button_down : in std_logic;

	value : out std_logic_vector (3 downto 0)
	);
end vibrato_button_ctl2;

architecture rtl of vibrato_button_ctl2 is

	signal cur_val : std_logic_vector (3 downto 0) := "0011";
	signal prev_butt_up : std_logic := '0';
	signal prev_butt_down : std_logic := '0';
begin

	value <= cur_val;

	process(clk)
	begin
		if(reset_n = '0') then
			cur_val <= "0011";
		elsif(clk 'event and clk = '1') then
			if(button_up = '1' and prev_butt_up = '0') then -- press button
				if not (cur_val = "1111") then
					cur_val <= cur_val + 1;
				end if;
				prev_butt_up <= button_up; 
			elsif (button_up = '0' and prev_butt_up = '1') then -- release button
				prev_butt_up <= button_up;
			end if;
			if(button_down = '1' and prev_butt_down = '0') then -- press button
				if not (cur_val = "0000") then
					cur_val <=cur_val - 1;
				end if;
				prev_butt_down <= button_down;
			elsif (button_down = '0' and prev_butt_down = '1') then -- release button
				prev_butt_down <= button_down;
			end if;
		end if;
	end process;
end architecture;
