library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity dist_button_ctl is
port (
	clk: in std_logic;
	reset_n : in std_logic;
	button_up : in std_logic;
	button_down : in std_logic;

	clip_value : out std_logic_vector (15 downto 0)
	);
end dist_button_ctl;

architecture rtl of dist_button_ctl is

	signal cur_clip : std_logic_vector (15 downto 0) := X"0080";
	signal prev_butt_up : std_logic := '0';
	signal prev_butt_down : std_logic := '0';
begin

	clip_value <= cur_clip;

	process(clk)
	begin
		if(reset_n = '0') then
			cur_clip <= X"0080";
		elsif(clk 'event and clk = '1') then
			if(button_up = '1' and prev_butt_up = '0') then -- press button
				if(cur_clip(14) = '0')then
					cur_clip <= cur_clip(14 downto 0) & '0';
				end if;
				prev_butt_up <= button_up; 
			elsif (button_up = '0' and prev_butt_up = '1') then -- release button
				prev_butt_up <= button_up;
			end if;
			if(button_down = '1' and prev_butt_down = '0') then -- press button
				if(cur_clip(0) = '0') then
					cur_clip <= '0' & cur_clip(15 downto 1); 
				end if;
--				cur_clip <= "00" & cur_clip(14 downto 1); 
				prev_butt_down <= button_down;
			elsif (button_down = '0' and prev_butt_down = '1') then -- release button
				prev_butt_down <= button_down;
			end if;
		end if;
	end process;

end architecture;
