----------------------------------------------------------------
-- 1633 by 16 RAM: 1633 slots, 16 bits per slot
--
-- Made by Navarun Jagatpal, April 10, 2007
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity RAM_1633_16 is
port (
               --In:
               clk : in std_logic;
               we   : in std_logic; -- Write-enable
               re   : in std_logic; -- Read-enable
               addr : in std_logic_vector(10 downto 0); --Address: 11 bits. This allows 0 to 2047, but the only valid

			   --inout:                                                                                                --addresses range from 0 to 1632.
               data_out : out std_logic_vector(15 downto 0); --Data In: 16 bits
			   data_in	: in std_logic_vector(15 downto 0)
       );
end RAM_1633_16;

architecture myRAM of RAM_1633_16 is
       type ram_type is array (1632 downto 0) of std_logic_vector(15 downto 0);
       signal RAM : ram_type;
       signal do_internal : std_logic_vector(7 downto 0); --Internal Copy of Data Out Signal
begin

       process(clk)
       begin
               if(clk'event and clk='1') then
                       if(we = '1') then
                               RAM(conv_integer(addr)) <= data_in;
                       end if;
                       if(re = '1') then
                               data_out <= RAM(conv_integer(addr)) ;
                       end if;
               end if;
       end process;
end myRAM;