library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity test_module is
port (
    clk : in std_logic;       --  Audio CODEC Chip Clock AUD_XCK (18.43 MHz)
    reset_n : in std_logic;

	-- for audio in
    audio_send : in std_logic;
   	data_in : in std_logic_vector(15 downto 0);
	selector : in std_logic;
	
	-- for audio out
    audio_req : in std_logic;
    data_out : out std_logic_vector(15 downto 0)

  );
end test_module;


architecture Behavioral of  test_module is     

signal audio_buf : std_logic_vector(15 downto 0);
begin


process (clk)
begin
	if (clk 'event and clk = '1') then
		if(audio_req = '1') then
			data_out <= audio_buf;
		end if;
		if(audio_send = '1') then
			if (selector = '1') then
				audio_buf <= data_in;
			else
				audio_buf <= (others => '0');
			end if;
		end if;
	end if;
end process;

end architecture;


